%define  ENABLE_ANSI  1

%define  gcl_cc       gcc

%define  maxpage      128*1024

%define  vssize	       64*1024
%define  bdssize        4*1024
%define  ihssize        8*1024
%define  frssize        8*1024

%define	 CVS_BUILD  0	

Name: gcl
Version: 2.6.1
Release: alt0.02
Summary: GNU Common Lisp
Copyright: LGPL
Group: Development/Lisp
URL: http://savannah.gnu.org/projects/gcl
Packager: Vadim V. Zhytnikov <vvzhy@altlinux.ru>

Source0: gcl-2.6.1-beta.tar.gz
Source1: init-gcl.lsp

Patch0: gcl-ansi-both.patch

Requires: tk tcl libreadline libncurses

PreReq: %__install_info

BuildRequires: libreadline-devel libncurses-devel tcl-devel tk-devel libiberty-devel libbfd-devel-static tetex texinfo

%description
The program GCL is an implementation of a subset of 
the Common Lisp Ansi standard. It is written in C and 
in Common Lisp, and is highly portable.  It includes 
those features in the original definition of Common Lisp,
(Guy Steele version 1.), as well as some features from 
the proposed new standard.

%if %ENABLE_ANSI 
This package is shipped with two GCL flavors.  First is
the traditional CLtL1 compliant GCL.  Second is experimental
ANSI Common Lisp compliant GCL version.  ANSI GCL is invoked 
if GCL_ANSI is set to "yes".
%endif

%prep
%if %CVS_BUILD
%setup -b 0 -ngcl
%else
%setup -b 0 
%endif

%if %ENABLE_ANSI 
%patch0 -p1
%endif

%build

%define   gcl_dir        %_builddir/%name-%version
%define   emacs_lisp     %_datadir/emacs/site-lisp	
%define   gcl_emacs      %_datadir/emacs/site-lisp/gcl

#rm -f configure
#autoconf_2.13

PROCESSOR_FLAGS=`echo "%optflags" | sed -e "s:%optflags_default::"`
export PROCESSOR_FLAGS

CC=%gcl_cc ; export CC ; %configure \
    --enable-tkconfig=/usr/lib      \
    --enable-tclconfig=/usr/lib     \
%if %ENABLE_ANSI 
    --enable-ansi  \
%else
    --disable-ansi \
%endif 
    --enable-maxpage=%maxpage \
    --enable-vssize=%vssize   \
    --enable-bdssize=%bdssize \
    --enable-ihssize=%ihssize \
    --enable-frssize=%frssize \
    --enable-infodir=%_infodir

make

%install
%define _findreq_default_method lib
# info files must be uncompressed
%define _compress_method no

install -d %buildroot%_infodir
install -d %buildroot%_man1dir
install -d %buildroot%gcl_emacs
install -d %buildroot%_includedir

make install DESTDIR=%buildroot \
    EMACS_SITE_LISP=%gcl_emacs \
    EMACS_DEFAULT_EL=%emacs_lisp/default.el

install -D -m644 %SOURCE1 %buildroot%_libdir/%name-%version/lsp/init.lsp
install -D -m644 ./elisp/*.el %buildroot%gcl_emacs
install -D -m644 ./man/man1/gcl.1 %buildroot%_man1dir/gcl.1
%if %ENABLE_ANSI 
install -D -m755 ./unixport/saved_gcl %buildroot%_libdir/%name-%version/unixport/saved_gcl
install -D -m644 ./unixport/init_gcl.lsp %buildroot%_libdir/%name-%version/unixport/init_gcl.lsp
install -D -m644 ./unixport/libgcl.a %buildroot%_libdir/%name-%version/unixport/libgcl.a
%endif

ln -f -s %_libdir/%name-%version/h/cmpinclude.h %buildroot%_includedir/cmpinclude.h	     

%define gcl_bindir %buildroot%_bindir
%define gcl_tk_demodir %buildroot%_libdir/%name-%version/gcl-tk/demos

cat %gcl_bindir/gcl | sed -e "s:%buildroot/usr:/usr:g" > %gcl_bindir/foo
rm -f %gcl_bindir/gcl  
mv %gcl_bindir/foo %gcl_bindir/gcl
chmod a+x %gcl_bindir/gcl

cat %gcl_tk_demodir/index.lisp | sed -e "s:%buildroot/usr:/usr:g" > %gcl_tk_demodir/foo
rm -f %gcl_tk_demodir/index.lisp  
mv %gcl_tk_demodir/foo %gcl_tk_demodir/index.lisp

%files
%_datadir/emacs/site-lisp/gcl
%dir %_libdir/%name-%version
%_libdir/%name-%version/cmpnew
%_libdir/%name-%version/gcl-tk
%_libdir/%name-%version/lsp
%_libdir/%name-%version/h
%_libdir/%name-%version/unixport
%_includedir/cmpinclude.h
%_infodir/gcl*
%_mandir/man1/gcl.1*
%_bindir/gcl
%doc readme* RELEASE* COPYING.LIB-2.0

%post
%install_info gcl-si.info gcl-tk.info gcl.info

%preun
%uninstall_info gcl-si.info gcl-tk.info gcl.info

%changelog
* Mon Sep 15 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.02
- configure recreation by autoconf is no longer required

* Fri Sep 12 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.01
- gcl 2.6.1 beta

* Thu Sep 04 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt8
- now package includes two images - tarditional CLtL1 gcl (invoked
  by default) and experimental ANSI CL gcl (invoked if GCL_ANSI is
  set to "yes"

* Tue Aug 26 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt7
- fix configure to respect -march
- patch to define all stacks size by configure
- enlarged stacks size

* Tue Aug 19 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt6
- spec fix

* Sun Aug 17 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt5
- set --build and --home as %_target_platform
- gcl %_libdir/gcl-%version added to the package

* Wed Jul 30 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt4
- set --buld and --home for proper arch subconfigure for gmp

* Sat Jul 12 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt3
- in configure --infodir replaced by --enable-infodir 
- gcl-tk patch

* Sun Jul 06 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt2
- fixed tkconfig and tclconfig

* Thu Jun 05 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt1
- gcl 2.5.3 bugfix release

* Fri Mar 21 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.2-alt1
- gcl 2.5.2 bugfix release

* Wed Mar 19 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.1-alt2
- fixed BuildRequires 

* Tue Mar 18 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.1-alt1
- gcl 2.5.1 release

* Fri Oct 04 2002 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.0-alt0.03
- gcl CVS 04.10.2002

* Sun Sep 29 2002 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.0-alt0.02
- gcl CVS 28.09.2002
- gcc 3.2 

* Mon Jul 15 2002 Vadim V. Zhytnikov <vvzhy@mail.ru> 2.5.0-alt0.01
- Initial ALT Linux release.
